/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    fdcan.h
  * @brief   This file contains all the function prototypes for
  *          the fdcan.c file
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FDCAN_H__
#define __FDCAN_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* USER CODE BEGIN Includes */
extern FDCAN_FilterTypeDef 		FDCANFilter1;
extern FDCAN_FilterTypeDef 		FDCANFilter2;
extern FDCAN_RxHeaderTypeDef 	RxHeader;
extern FDCAN_TxHeaderTypeDef   	TxHeader;

extern uint8_t RxBufferOne[1];
extern uint8_t RxBufferTwo[2];
extern uint8_t RxBufferThree[3];
extern uint8_t RxBufferFour[4];
extern uint8_t RxBufferFive[5];
extern uint8_t RxBufferSix[6];
extern uint8_t RxBufferSeven[7];
extern uint8_t RxBufferEight[8];
/* USER CODE END Includes */

extern FDCAN_HandleTypeDef hfdcan1;

extern FDCAN_HandleTypeDef hfdcan2;

/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

void MX_FDCAN1_Init(void);
void MX_FDCAN2_Init(void);

/* USER CODE BEGIN Prototypes */
void FDCAN1FilterConfig(void);
void FDCAN2FilterConfig(void);
void FDCAN2TxHeaderConfig(void);
void FDCanChooseSize(uint8_t *buffer);
void FDCAN1_Rx(int Length);
void FDCAN2_Tx(int Length);
/* USER CODE END Prototypes */

#ifdef __cplusplus
}
#endif

#endif /* __FDCAN_H__ */

