/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    fdcan.c
  * @brief   This file provides code for the configuration
  *          of the FDCAN instances.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "fdcan.h"

/* USER CODE BEGIN 0 */
#include "string.h"
FDCAN_FilterTypeDef 	FDCANFilter1;
FDCAN_FilterTypeDef 	FDCANFilter2;
FDCAN_RxHeaderTypeDef   RxHeader;
FDCAN_TxHeaderTypeDef   TxHeader;

uint8_t RxBufferOne[1];
uint8_t RxBufferTwo[2];
uint8_t RxBufferThree[3];
uint8_t RxBufferFour[4];
uint8_t RxBufferFive[5];
uint8_t RxBufferSix[6];
uint8_t RxBufferSeven[7];
uint8_t RxBufferEight[8];
/* USER CODE END 0 */

FDCAN_HandleTypeDef hfdcan1;
FDCAN_HandleTypeDef hfdcan2;

/* FDCAN1 init function */
void MX_FDCAN1_Init(void)
{

  /* USER CODE BEGIN FDCAN1_Init 0 */

  /* USER CODE END FDCAN1_Init 0 */

  /* USER CODE BEGIN FDCAN1_Init 1 */

  /* USER CODE END FDCAN1_Init 1 */
  hfdcan1.Instance = FDCAN1;
  hfdcan1.Init.ClockDivider = FDCAN_CLOCK_DIV1;
  hfdcan1.Init.FrameFormat = FDCAN_FRAME_CLASSIC;
  hfdcan1.Init.Mode = FDCAN_MODE_BUS_MONITORING;
  hfdcan1.Init.AutoRetransmission = DISABLE;
  hfdcan1.Init.TransmitPause = ENABLE;
  hfdcan1.Init.ProtocolException = DISABLE;
  hfdcan1.Init.NominalPrescaler = 40;
  hfdcan1.Init.NominalSyncJumpWidth = 1;
  hfdcan1.Init.NominalTimeSeg1 = 12;
  hfdcan1.Init.NominalTimeSeg2 = 3;
  hfdcan1.Init.DataPrescaler = 4;
  hfdcan1.Init.DataSyncJumpWidth = 1;
  hfdcan1.Init.DataTimeSeg1 = 7;
  hfdcan1.Init.DataTimeSeg2 = 2;
  hfdcan1.Init.StdFiltersNbr = 0;
  hfdcan1.Init.ExtFiltersNbr = 0;
  hfdcan1.Init.TxFifoQueueMode = FDCAN_TX_FIFO_OPERATION;
  if (HAL_FDCAN_Init(&hfdcan1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN FDCAN1_Init 2 */

  /* USER CODE END FDCAN1_Init 2 */

}
/* FDCAN2 init function */
void MX_FDCAN2_Init(void)
{

  /* USER CODE BEGIN FDCAN2_Init 0 */

  /* USER CODE END FDCAN2_Init 0 */

  /* USER CODE BEGIN FDCAN2_Init 1 */

  /* USER CODE END FDCAN2_Init 1 */
  hfdcan2.Instance = FDCAN2;
  hfdcan2.Init.ClockDivider = FDCAN_CLOCK_DIV1;
  hfdcan2.Init.FrameFormat = FDCAN_FRAME_CLASSIC;
  hfdcan2.Init.Mode = FDCAN_MODE_NORMAL;
  hfdcan2.Init.AutoRetransmission = DISABLE;
  hfdcan2.Init.TransmitPause = ENABLE;
  hfdcan2.Init.ProtocolException = DISABLE;
  hfdcan2.Init.NominalPrescaler = 20;
  hfdcan2.Init.NominalSyncJumpWidth = 1;
  hfdcan2.Init.NominalTimeSeg1 = 12;
  hfdcan2.Init.NominalTimeSeg2 = 3;
  hfdcan2.Init.DataPrescaler = 4;
  hfdcan2.Init.DataSyncJumpWidth = 1;
  hfdcan2.Init.DataTimeSeg1 = 7;
  hfdcan2.Init.DataTimeSeg2 = 2;
  hfdcan2.Init.StdFiltersNbr = 1;
  hfdcan2.Init.ExtFiltersNbr = 0;
  hfdcan2.Init.TxFifoQueueMode = FDCAN_TX_FIFO_OPERATION;
  if (HAL_FDCAN_Init(&hfdcan2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN FDCAN2_Init 2 */

  /* USER CODE END FDCAN2_Init 2 */

}

static uint32_t HAL_RCC_FDCAN_CLK_ENABLED=0;

void HAL_FDCAN_MspInit(FDCAN_HandleTypeDef* fdcanHandle)
{

  GPIO_InitTypeDef GPIO_InitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInit = {0};
  if(fdcanHandle->Instance==FDCAN1)
  {
  /* USER CODE BEGIN FDCAN1_MspInit 0 */

  /* USER CODE END FDCAN1_MspInit 0 */

  /** Initializes the peripherals clocks
  */
    PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_FDCAN;
    PeriphClkInit.FdcanClockSelection = RCC_FDCANCLKSOURCE_PLL;
    if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
    {
      Error_Handler();
    }

    /* FDCAN1 clock enable */
    HAL_RCC_FDCAN_CLK_ENABLED++;
    if(HAL_RCC_FDCAN_CLK_ENABLED==1){
      __HAL_RCC_FDCAN_CLK_ENABLE();
    }

    __HAL_RCC_GPIOA_CLK_ENABLE();
    /**FDCAN1 GPIO Configuration
    PA11     ------> FDCAN1_RX
    PA12     ------> FDCAN1_TX
    */
    GPIO_InitStruct.Pin = GPIO_PIN_11|GPIO_PIN_12;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.Pull = GPIO_NOPULL;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
    GPIO_InitStruct.Alternate = GPIO_AF9_FDCAN1;
    HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /* USER CODE BEGIN FDCAN1_MspInit 1 */

  /* USER CODE END FDCAN1_MspInit 1 */
  }
  else if(fdcanHandle->Instance==FDCAN2)
  {
  /* USER CODE BEGIN FDCAN2_MspInit 0 */

  /* USER CODE END FDCAN2_MspInit 0 */

  /** Initializes the peripherals clocks
  */
    PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_FDCAN;
    PeriphClkInit.FdcanClockSelection = RCC_FDCANCLKSOURCE_PLL;
    if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
    {
      Error_Handler();
    }

    /* FDCAN2 clock enable */
    HAL_RCC_FDCAN_CLK_ENABLED++;
    if(HAL_RCC_FDCAN_CLK_ENABLED==1){
      __HAL_RCC_FDCAN_CLK_ENABLE();
    }

    __HAL_RCC_GPIOB_CLK_ENABLE();
    /**FDCAN2 GPIO Configuration
    PB12     ------> FDCAN2_RX
    PB13     ------> FDCAN2_TX
    */
    GPIO_InitStruct.Pin = GPIO_PIN_12|GPIO_PIN_13;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
    GPIO_InitStruct.Pull = GPIO_NOPULL;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
    GPIO_InitStruct.Alternate = GPIO_AF9_FDCAN2;
    HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /* USER CODE BEGIN FDCAN2_MspInit 1 */

  /* USER CODE END FDCAN2_MspInit 1 */
  }
}

void HAL_FDCAN_MspDeInit(FDCAN_HandleTypeDef* fdcanHandle)
{

  if(fdcanHandle->Instance==FDCAN1)
  {
  /* USER CODE BEGIN FDCAN1_MspDeInit 0 */

  /* USER CODE END FDCAN1_MspDeInit 0 */
    /* Peripheral clock disable */
    HAL_RCC_FDCAN_CLK_ENABLED--;
    if(HAL_RCC_FDCAN_CLK_ENABLED==0){
      __HAL_RCC_FDCAN_CLK_DISABLE();
    }

    /**FDCAN1 GPIO Configuration
    PA11     ------> FDCAN1_RX
    PA12     ------> FDCAN1_TX
    */
    HAL_GPIO_DeInit(GPIOA, GPIO_PIN_11|GPIO_PIN_12);

  /* USER CODE BEGIN FDCAN1_MspDeInit 1 */

  /* USER CODE END FDCAN1_MspDeInit 1 */
  }
  else if(fdcanHandle->Instance==FDCAN2)
  {
  /* USER CODE BEGIN FDCAN2_MspDeInit 0 */

  /* USER CODE END FDCAN2_MspDeInit 0 */
    /* Peripheral clock disable */
    HAL_RCC_FDCAN_CLK_ENABLED--;
    if(HAL_RCC_FDCAN_CLK_ENABLED==0){
      __HAL_RCC_FDCAN_CLK_DISABLE();
    }

    /**FDCAN2 GPIO Configuration
    PB12     ------> FDCAN2_RX
    PB13     ------> FDCAN2_TX
    */
    HAL_GPIO_DeInit(GPIOB, GPIO_PIN_12|GPIO_PIN_13);

  /* USER CODE BEGIN FDCAN2_MspDeInit 1 */

  /* USER CODE END FDCAN2_MspDeInit 1 */
  }
}

/* USER CODE BEGIN 1 */

/* This function configures the first FDCAN filter that will be used to receive
 * CAN data via CANH and CANL on the GT-900. */
void FDCAN1FilterConfig()
{
	FDCANFilter1.IdType = FDCAN_STANDARD_ID;
	FDCANFilter1.FilterIndex = 0;
	FDCANFilter1.FilterType = FDCAN_FILTER_MASK;
	FDCANFilter1.FilterConfig = FDCAN_FILTER_TO_RXFIFO0;
	FDCANFilter1.FilterID1 = 0x01;
	FDCANFilter1.FilterID2 = 0x02;
	HAL_FDCAN_ConfigFilter(&hfdcan1, &FDCANFilter1);
}

/* This function configures the second FDCAN filter that will be used to transmit
 * CAN data via CAN2H and CAN2L on the GT-900. */
void FDCAN2FilterConfig()
{
	FDCANFilter2.IdType = FDCAN_STANDARD_ID;
	FDCANFilter2.FilterIndex = 0;
	FDCANFilter2.FilterType = FDCAN_FILTER_MASK;
	FDCANFilter2.FilterConfig = FDCAN_FILTER_TO_RXFIFO1;
	FDCANFilter2.FilterID1 = 0x03;
	FDCANFilter2.FilterID2 = 0x04;
	HAL_FDCAN_ConfigFilter(&hfdcan2, &FDCANFilter2);
}

/* This function configures the TxHeader of the FDCAN2 interface.
 * The data length is not defined in this case, since we define that dynamically
 * depending on the length that is defined in the RxHeader, that will be received
 * from the SGT-800. */
void FDCAN2TxHeaderConfig()
{
	//TxHeader.Identifier = 0x601;
	TxHeader.IdType = FDCAN_STANDARD_ID;
	TxHeader.TxFrameType = FDCAN_DATA_FRAME;
	TxHeader.ErrorStateIndicator = FDCAN_ESI_ACTIVE;
	TxHeader.BitRateSwitch = FDCAN_BRS_OFF;
	TxHeader.FDFormat = FDCAN_CLASSIC_CAN;
	TxHeader.DataLength = FDCAN_DLC_BYTES_8;
	TxHeader.TxEventFifoControl = FDCAN_NO_TX_EVENTS;
	TxHeader.MessageMarker = 0;
}

/* This function is used to determine the DLC (Data Length Code) of the received CAN message. */
void FDCanChooseSize(uint8_t *buffer)
{
	/* This function sets the CAN1_ON pin high, since that is a required condition
	 * for CAN communication to work. */
	HAL_GPIO_WritePin(CAN1_ON_GPIO_Port, CAN1_ON_Pin, GPIO_PIN_SET);



	/* This function handles the receival of the CAN data that's sent by the STG-800.
	 * This function is part of stm32g4xx_hal_fdcan.c and can be further examined by
	 * highlighting the function name and opening the declaration by pressing F3.
	 *
	 * This function also receives the header information, included in  the CAN message from the STG-800
	 * and saves that information in RxHeader. */
	HAL_FDCAN_GetRxMessage(&hfdcan1, FDCAN_RX_FIFO0, &RxHeader, buffer);



	/* This function sets the CAN1_ON pin low again, after the message has been received. */
	HAL_GPIO_WritePin(CAN1_ON_GPIO_Port, CAN1_ON_Pin, GPIO_PIN_RESET);
}

void FDCAN1_Rx(int Length)
{

	HAL_FDCAN_Start(&hfdcan1);

	/* This sets the CAN address of the transmission header equal to the address of the receival header. */
	TxHeader.Identifier = RxHeader.Identifier;



	/* This function sets the CAN1_ON pin high, since that is a required condition
	 * for CAN communication to work. */
	HAL_GPIO_WritePin(CAN1_ON_GPIO_Port, CAN1_ON_Pin, GPIO_PIN_SET);



	/* This function switches to a different case, depending on the length of the received CAN message. */
	switch(Length)
		{
		case 1:



			/* This function handles the receival of the CAN data that's sent by the STG-800.
			 * This function is part of stm32g4xx_hal_fdcan.c and can be further examined by
			 * highlighting the function name and opening the declaration by pressing F3.
			 * Each case from 1 - 8 has a dedicated buffer variable, corresponding to the size
			 * of the DLC of the CAN message that's received from the STG-800.
			 * In this case we're using 'RxBufferOne[1]', because this case triggers when DLC = 1 */
			HAL_FDCAN_GetRxMessage(&hfdcan1, FDCAN_RX_FIFO0, &RxHeader, RxBufferOne);



			/* These functions are used to clear every other buffer than the one being used,
			 * in case the length of the CAN message received from the STG-800 changes, while
			 * the system is running. */
			memset(RxBufferTwo, 0, sizeof(RxBufferTwo));
			memset(RxBufferThree, 0, sizeof(RxBufferThree));
			memset(RxBufferFour, 0, sizeof(RxBufferFour));
			memset(RxBufferFive, 0, sizeof(RxBufferFive));
			memset(RxBufferSix, 0, sizeof(RxBufferSix));
			memset(RxBufferSeven, 0, sizeof(RxBufferSeven));
			memset(RxBufferEight, 0, sizeof(RxBufferEight));



			/* This sets the DLC of TxHeader equal to the DLC of the RxHeader. */
			TxHeader.DataLength = FDCAN_DLC_BYTES_1;
			break;



			/* The following cases all have the same structure. The corresponding buffer is used,
			 * the other buffer are cleared, and the correct DLC will be used. */
		case 2:
			HAL_FDCAN_GetRxMessage(&hfdcan1, FDCAN_RX_FIFO0, &RxHeader, RxBufferTwo);
			memset(RxBufferOne, 0, sizeof(RxBufferOne));
			memset(RxBufferThree, 0, sizeof(RxBufferThree));
			memset(RxBufferFour, 0, sizeof(RxBufferFour));
			memset(RxBufferFive, 0, sizeof(RxBufferFive));
			memset(RxBufferSix, 0, sizeof(RxBufferSix));
			memset(RxBufferSeven, 0, sizeof(RxBufferSeven));
			memset(RxBufferEight, 0, sizeof(RxBufferEight));
			TxHeader.DataLength = FDCAN_DLC_BYTES_2;
			break;
		case 3:
			HAL_FDCAN_GetRxMessage(&hfdcan1, FDCAN_RX_FIFO0, &RxHeader, RxBufferThree);
			memset(RxBufferOne, 0, sizeof(RxBufferOne));
			memset(RxBufferTwo, 0, sizeof(RxBufferTwo));
			memset(RxBufferFour, 0, sizeof(RxBufferFour));
			memset(RxBufferFive, 0, sizeof(RxBufferFive));
			memset(RxBufferSix, 0, sizeof(RxBufferSix));
			memset(RxBufferSeven, 0, sizeof(RxBufferSeven));
			memset(RxBufferEight, 0, sizeof(RxBufferEight));
			TxHeader.DataLength = FDCAN_DLC_BYTES_3;
			break;
		case 4:
			HAL_FDCAN_GetRxMessage(&hfdcan1, FDCAN_RX_FIFO0, &RxHeader, RxBufferFour);
			memset(RxBufferOne, 0, sizeof(RxBufferOne));
			memset(RxBufferTwo, 0, sizeof(RxBufferTwo));
			memset(RxBufferThree, 0, sizeof(RxBufferThree));
			memset(RxBufferFive, 0, sizeof(RxBufferFive));
			memset(RxBufferSix, 0, sizeof(RxBufferSix));
			memset(RxBufferSeven, 0, sizeof(RxBufferSeven));
			memset(RxBufferEight, 0, sizeof(RxBufferEight));
			TxHeader.DataLength = FDCAN_DLC_BYTES_4;
			break;
		case 5:
			HAL_FDCAN_GetRxMessage(&hfdcan1, FDCAN_RX_FIFO0, &RxHeader, RxBufferFive);
			memset(RxBufferOne, 0, sizeof(RxBufferOne));
			memset(RxBufferTwo, 0, sizeof(RxBufferTwo));
			memset(RxBufferThree, 0, sizeof(RxBufferThree));
			memset(RxBufferFour, 0, sizeof(RxBufferFour));
			memset(RxBufferSix, 0, sizeof(RxBufferSix));
			memset(RxBufferSeven, 0, sizeof(RxBufferSeven));
			memset(RxBufferEight, 0, sizeof(RxBufferEight));
			TxHeader.DataLength = FDCAN_DLC_BYTES_5;
			break;
		case 6:
			HAL_FDCAN_GetRxMessage(&hfdcan1, FDCAN_RX_FIFO0, &RxHeader, RxBufferSix);
			memset(RxBufferOne, 0, sizeof(RxBufferOne));
			memset(RxBufferTwo, 0, sizeof(RxBufferTwo));
			memset(RxBufferThree, 0, sizeof(RxBufferThree));
			memset(RxBufferFour, 0, sizeof(RxBufferFour));
			memset(RxBufferFive, 0, sizeof(RxBufferFive));
			memset(RxBufferSeven, 0, sizeof(RxBufferSeven));
			memset(RxBufferEight, 0, sizeof(RxBufferEight));
			TxHeader.DataLength = FDCAN_DLC_BYTES_6;
			break;
		case 7:
			HAL_FDCAN_GetRxMessage(&hfdcan1, FDCAN_RX_FIFO0, &RxHeader, RxBufferSeven);
			memset(RxBufferOne, 0, sizeof(RxBufferOne));
			memset(RxBufferTwo, 0, sizeof(RxBufferTwo));
			memset(RxBufferThree, 0, sizeof(RxBufferThree));
			memset(RxBufferFour, 0, sizeof(RxBufferFour));
			memset(RxBufferFive, 0, sizeof(RxBufferFive));
			memset(RxBufferSix, 0, sizeof(RxBufferSix));
			memset(RxBufferEight, 0, sizeof(RxBufferEight));
			TxHeader.DataLength = FDCAN_DLC_BYTES_7;
			break;
		case 8:
			HAL_FDCAN_GetRxMessage(&hfdcan1, FDCAN_RX_FIFO0, &RxHeader, RxBufferEight);
			memset(RxBufferOne, 0, sizeof(RxBufferOne));
			memset(RxBufferTwo, 0, sizeof(RxBufferTwo));
			memset(RxBufferThree, 0, sizeof(RxBufferThree));
			memset(RxBufferFour, 0, sizeof(RxBufferFour));
			memset(RxBufferFive, 0, sizeof(RxBufferFive));
			memset(RxBufferSix, 0, sizeof(RxBufferSix));
			memset(RxBufferSeven, 0, sizeof(RxBufferSeven));
			TxHeader.DataLength = FDCAN_DLC_BYTES_8;
			break;
		}



	/* This sets the CAN1_ON low again, after CAN communication */
	HAL_GPIO_WritePin(CAN1_ON_GPIO_Port, CAN1_ON_Pin, GPIO_PIN_RESET);
}

void FDCAN2_Tx(int Length)
{

	HAL_FDCAN_Start(&hfdcan2);

	/* This function sets the CAN2_ON pin high, since that is a required condition
	 * for CAN communication to work. */
	HAL_GPIO_WritePin(CAN2_ON_GPIO_Port, CAN2_ON_Pin, GPIO_PIN_SET);



	/* This function switches to a different case, depending on the DLC of the received CAN message.
	 * Each case uses the corresponding buffer, based on the message length. */
	switch(Length)
		{
		case 1:
			HAL_FDCAN_AddMessageToTxFifoQ(&hfdcan2, &TxHeader, RxBufferOne);
			break;
		case 2:
			HAL_FDCAN_AddMessageToTxFifoQ(&hfdcan2, &TxHeader, RxBufferTwo);
			break;
		case 3:
			HAL_FDCAN_AddMessageToTxFifoQ(&hfdcan2, &TxHeader, RxBufferThree);
			break;
		case 4:
			HAL_FDCAN_AddMessageToTxFifoQ(&hfdcan2, &TxHeader, RxBufferFour);
			break;
		case 5:
			HAL_FDCAN_AddMessageToTxFifoQ(&hfdcan2, &TxHeader, RxBufferFive);
			break;
		case 6:
			HAL_FDCAN_AddMessageToTxFifoQ(&hfdcan2, &TxHeader, RxBufferSix);
			break;
		case 7:
			HAL_FDCAN_AddMessageToTxFifoQ(&hfdcan2, &TxHeader, RxBufferSeven);
			break;
		case 8:
			HAL_FDCAN_AddMessageToTxFifoQ(&hfdcan2, &TxHeader, RxBufferEight);
			break;
		}



	/* This sets the CAN2_ON low again, after CAN communication */
	HAL_GPIO_WritePin(CAN2_ON_GPIO_Port, CAN2_ON_Pin, GPIO_PIN_RESET);



	/* This is a delay of 250ms. */
	HAL_Delay(250);
}

/* USER CODE END 1 */
